/* NcFTP ARexx Module for AWeb 1.2 FTP transfers*/

parse ARG Arguments

if words(Arguments) < 3 then do 
   Error_Message='T:AWebNcFTP-Error-Message-'time(S)
   call open(fp1, Error_Message, W)
      call writeln(fp1, '<HTML><H2><I>AWebNcFTP.rexx</I></H2> Error<BR><HR>')
      call writech(fp1, 'Use AWeb Network 3 Arguments: ')
      call writeln(fp1, '<B>AWebNcFTP.rexx *%s *%s *%s</B><BR></HTML>')
   call close(fp1) 
   address AWEB.1 'OPEN file://localhost/'Error_Message
   address command 'delete <>NIL: 'Error_Message
   exit 0
end  

def_drawer = 'RAM:'
host   = trim(substr(word(Arguments, 1), 2))
path   = trim(substr(word(Arguments, 2), 2))
screen = trim(substr(word(Arguments, 3), 2))

current_time = time(S)
ncftp_input  = 'T:awebncftp'current_time'.ncftp_input' 
ncftp_output = 'T:awebncftp'current_time'.ncftp_output'
transfer_result = 'T:awebncftp'current_time'.ncftp_result'
if screen='' then
   screen='AWeb'
filesize = -1

/* Determine whether PATH points to a file, directory, or anything at all*/
call open(fp2, ncftp_input, W)
   call writeln(fp2, 'size /'path)
   call writeln(fp2, 'cd /'path)
   call writeln(fp2, 'quit')
call close(fp2)
    
address command 'AmiTCP:bin/ncftp <'ncftp_input' >'ncftp_output' -V 0 -N 'host
address command 'delete <>NIL: 'ncftp_input
address command 'search  >'transfer_result' 'ncftp_output' NONUM "550 "'
address command 'search >>'transfer_result' 'ncftp_output' NONUM "213 "' 
address command 'search >>'transfer_result' 'ncftp_output' NONUM "No#? directory" PATTERN'

call open(fp3, transfer_result, R)
   test=subword(readln(fp3),3)
   type=subword(readln(fp3),2)
call close(fp3)
if test='' then do
   call open(fp4, transfer_result, R)
      filesize = subword(readln(fp4),2)
   call close(fp4)
end
address command 'delete <>NIL: 'transfer_result' 'ncftp_output

if (filesize=-1) then
   if abbrev(type,'No such file or directory')|abbrev(type,'Not a directory') then do
      address command 'requestchoice >NIL: TITLE "FTP:  'path'" BODY "Invalid PATH/FILENAME" "OK" PUBSCREEN 'screen
      exit 0
   end

if test='' & filesize='' then do
   address command 'requestchoice >NIL: TITLE "FTP:  'host'" BODY "HOST Access Error" "OK" PUBSCREEN 'screen
   exit 0       
end

/* PATH points to a file, so attempt to download file */
if ~abbrev(test,'not a plain file') then do
   filename=strip(right(path,length(path) - lastpos('/',path)))
   view_dest = 'T:'current_time'-'filename
   response_file == 'T:awebncftp'current_time'.response'
   address command 'requestchoice >'response_file' TITLE "FTP file:  'filename'" BODY "Select a Download Option." "SAVE|VIEW|CANCEL" PUBSCREEN 'screen
   call open(fp2, response_file,r)
   response=readln(fp2)
   call close(fp2)
   address command 'delete <>NIL: 'response_file
   if response>0 then do
      if response=1 then do
         destin_result='T:awebncftp'current_time'.destin_result'
         address command 'requestfile 'def_drawer' FILE 'filename' TITLE "Select Download Destination" PUBSCREEN 'screen' >'destin_result
         call open(fp2,destin_result,r)
         destination = readln(fp2)
         call close(fp2)
         address command 'delete <>NIL: 'destin_result
      end
      else
         destination=view_dest
      call open(fp2, ncftp_input, W)
         call writeln(fp2, 'bin')
         call writeln(fp2, 'verbose 2')
         call writeln(fp2, 'get /'path' 'destination)
         call writeln(fp2, 'quit')
      call close(fp2)

      /* Background Downloading Window --Assumption: Font Size is <= Topaz 8 */
      call open('Progress_Message','RAW:1024/800/175/0/FTP Background Reminder: 'time(n)'/cds/NOSIZE/INACTIVE/SCREEN'screen)
         call writeln('Progress_Message', 'NcFTP TRANSFERING...')
         call writech('Progress_Message', 'HOST: ')
         call writeln('Progress_Message', substr(host,1,14))
         call writech('Progress_Message', 'FILE: ')
         call writeln('Progress_Message', substr(filename,1,14))
         call writech('Progress_Message', 'SIZE: ')
         call writech('Progress_Message', trim(substr(filesize,1,8)))
         call writech('Progress_Message', ' Bytes')
         address command 'AmiTCP:bin/ncftp <'ncftp_input' >'ncftp_output' -V -1 -N 'host
         address command 'delete <>NIL: 'ncftp_input
         address command 'search >'transfer_result' 'ncftp_output' NONUM "Transfer Complete."'
      call close('Progress_Message')
      call open(fp3, transfer_result, R)
         test=strip(word(readln(fp3), 3))
      call close(fp3)
      address command 'delete <>NIL: 'transfer_result' 'ncftp_output
      if abbrev(test,'complete',8) then 
         if response=1 then
            address command 'requestchoice >NIL: TITLE "FTP file:  'filename'" BODY "FTP Transfer Complete." "OK" PUBSCREEN 'screen
         else do 
            address AWEB.1 'OPEN file://localhost/'destination
         end
      else 
         address command 'requestchoice >NIL: TITLE "FTP file:  'filename'" BODY "FTP Transfer Error.*NUnable to Download." "OK" PUBSCREEN 'screen
   end
end
/* PATH points to a directory, so get LISTing */
else do 
      if path~='' then
         if (substr(path,length(path),1)~='/') then
            path=path'/'
      call open(fp1, ncftp_input, W)
         call writeln(fp1, 'dir /'path)
         call writeln(fp1, 'quit')
      call close(fp1)
      directory_html  = 'T:'host'-'current_time
      ncftp_output = directory_html'+'
      address command 'AmiTCP:bin/ncftp <'ncftp_input' >'ncftp_output' -V -1 -N 'host

      call open(fp3,directory_html,w)   
      call writeln(fp3,'<html><head><title>ftp://'host)
      call writech(fp3,path'</title></head><body><pre>')                              
      call writeln(fp3,'<h2>Index of <I>ftp://'host'/'path'</I></h2>')                                 
      call writeln(fp3,'<hr> <B>Name                             Date                    Bytes</B><hr>')

      call open(fp2,ncftp_output,r)                                                                    
      call readln(fp2)
      call readln(fp2)

      if path~='' then do
        path='/'path 
        path=substr(path,1,length(path)-1)
        parent=strip(left(path, lastpos('/',path)))
        call writeln(fp3,'<a href="ftp://'host parent'">(parent)</a>') 
      end
    
      do until eof(fp2)                                                                                   
         line=readln(fp2) 
         text=word(line,1)' 'word(line,9)' 'word(line,5)' 'word(line,6)'-'word(line,7)right(word(line,8),6,'-')
             
         if words(text)=4 then do                                                                    
            parse var text attribute' 'filename' 'size' 'date                                                        
            if length(filename)>30 then 
               htmlname=left(filename,30)'</a>'
            else
               htmlname=filename'</a>'                                                                                                      
            if substr(attribute,1,1)='d'|substr(attribute,1,1)='l' then 
               call writeln(fp3,'<a href="ftp://'host path'/'filename'">'left(htmlname,29,' ')'  'right(date,15)'         'right('-',10)) 
            else                                                                                    
               call writeln(fp3,'<a href="ftp://'host path'/'filename'">'left(htmlname,29,' ')'  'right(date,15)'         'right(size,10)) 
         end                                                                                           
      end                                                                                               
      call writeln(fp3,'</pre><hr><h4><I>AWebNcFTP</I></h4>')
      call writeln(fp3, '</body><HTML>')
      call close(fp2)
      call close(fp3)
      address AWEB.1 'OPEN file://localhost/'directory_html' RELOAD'
      address command 'delete <>NIL: 'ncftp_output' 'ncftp_input
end

exit 0
